#   this  is   CCCS.DIGITAL48.tcl
  


proc define-DIGITAL48 {} {
  global resource mname IPslot IPslots

  set mname IPDIO48
  set slot  [lsearch $IPslots $IPslot(IPDIO48)]

  log "deleting all IP-Digital48 registers"
  EG "register :pattern '/$resource/$mname.*' !delete"

  set PITBase(X) 0x00
  set PITBase(Y) 0x40

      define-register xIP ManID        "-s $slot -o 0x09 -d id -p ro -w 8 -zx"
      define-register xIP ModID        "-s $slot -o 0x0b -d id -p ro -w 8 -zx"

      foreach i [list X Y] {
         set RegBase $PITBase($i)
         define-register xIP PGCR_$i   "-s $slot -o [expr $RegBase + 0x01] -d io -p rw -w 8 -zx"
         define-register xIP PSRR_$i   "-s $slot -o [expr $RegBase + 0x03] -d io -p rw -w 8 -zx"
         define-register xIP PADDR_$i  "-s $slot -o [expr $RegBase + 0x05] -d io -p rw -w 8 -zx"
         define-register xIP PBDDR_$i  "-s $slot -o [expr $RegBase + 0x07] -d io -p rw -w 8 -zx"
         define-register xIP PCDDR_$i  "-s $slot -o [expr $RegBase + 0x09] -d io -p rw -w 8 -zx"
         define-register xIP PIVR_$i   "-s $slot -o [expr $RegBase + 0x0B] -d io -p rw -w 8 -zx"
         define-register xIP PACR_$i   "-s $slot -o [expr $RegBase + 0x0D] -d io -p rw -w 8 -zx"
         define-register xIP PBCR_$i   "-s $slot -o [expr $RegBase + 0x0F] -d io -p rw -w 8 -zx"
         define-register xIP PADR_$i   "-s $slot -o [expr $RegBase + 0x11] -d io -p rw -w 8 -zx"
         define-register xIP PBDR_$i   "-s $slot -o [expr $RegBase + 0x13] -d io -p rw -w 8 -zx"
         define-register xIP PAAR_$i   "-s $slot -o [expr $RegBase + 0x15] -d io -p ro -w 8 -zx"
         define-register xIP PBAR_$i   "-s $slot -o [expr $RegBase + 0x17] -d io -p ro -w 8 -zx"
         define-register xIP PCDR_$i   "-s $slot -o [expr $RegBase + 0x19] -d io -p rw -w 8 -zx"
         define-register xIP PSR_$i    "-s $slot -o [expr $RegBase + 0x1B] -d io -p rw -w 8 -zx"
         define-register xIP TCR_$i    "-s $slot -o [expr $RegBase + 0x21] -d io -p rw -w 8 -zx"
         define-register xIP TIVR_$i   "-s $slot -o [expr $RegBase + 0x23] -d io -p rw -w 8 -zx"
         define-register xIP CPRH_$i   "-s $slot -o [expr $RegBase + 0x27] -d io -p rw -w 8 -zx"
         define-register xIP CPRM_$i   "-s $slot -o [expr $RegBase + 0x29] -d io -p rw -w 8 -zx"
         define-register xIP CPRL_$i   "-s $slot -o [expr $RegBase + 0x2B] -d io -p rw -w 8 -zx"
         define-register xIP CNTRH_$i  "-s $slot -o [expr $RegBase + 0x2F] -d io -p ro -w 8 -zx"
         define-register xIP CNTRM_$i  "-s $slot -o [expr $RegBase + 0x31] -d io -p ro -w 8 -zx"
         define-register xIP CNTRL_$i  "-s $slot -o [expr $RegBase + 0x33] -d io -p ro -w 8 -zx"
         define-register xIP TSR_$i    "-s $slot -o [expr $RegBase + 0x35] -d io -p rw -w 8 -zx"
      }

#    some 4 bit registers for the limit switches
      foreach i [list X Y] {
         set RegBase $PITBase($i)
         define-register xIP PADR_[set i]_L   "-s $slot -o [expr $RegBase + 0x11] -d io -p rw -w 8 -l4 -b0 -zx"
         define-register xIP PADR_[set i]_H   "-s $slot -o [expr $RegBase + 0x11] -d io -p rw -w 8 -l4 -b4 -zx"
         define-register xIP PBDR_[set i]_L   "-s $slot -o [expr $RegBase + 0x13] -d io -p rw -w 8 -l4 -b0 -zx"
         define-register xIP PBDR_[set i]_H   "-s $slot -o [expr $RegBase + 0x13] -d io -p rw -w 8 -l4 -b4 -zx"
      }
}
